/* Calculate the netmask for a prefix (eg. 24) */
function mask_for_prefix( prefix )
{
   mask = 0xffffffff;
   mask = mask >>> prefix;
   mask ^= 0xffffffff;
   
   return mask;
}

/* decimal to hex */
function d2h(d) {return d.toString(16);}

/* convert to dotted quad */
function to_dot_quad( addr )
{
   function ip_component( addr, n )
   {
      return ((addr >> (24 - 8 * n)) & 0xff);
   }

   return        ip_component(addr, 0)
         + '.' + ip_component(addr, 1)
         + '.' + ip_component(addr, 2)
         + '.' + ip_component(addr, 3);
}

/* dotted quad string to number */
function dot_quad_to_number( dotquad )
{
   var m = /^(\d+)\.(\d+)\.(\d+)\.(\d+)$/.exec(dotquad)
   return (m[1] << 24) | (m[2] << 16) | (m[3] << 8) | m[4]; 
}

function cidr_to_start_end( addr, prefix )
{
    mask = mask_for_prefix( prefix );
    start = addr & mask;
    end = (addr & mask) + (mask ^ 0xffffffff);
    
    return [start, end];
}

function dotted_cidr_to_start_end( ipaddress, prefix )
{
    result = cidr_to_start_end( dot_quad_to_number(ipaddress), prefix);
    return [ to_dot_quad(result[0]), to_dot_quad( result[1] ) ];
}

function cidr_info( ipaddress, prefix )
{
    result = dotted_cidr_to_start_end( ipaddress, prefix );
    netmask = to_dot_quad( mask_for_prefix( prefix ) );
    
    return 'Network: ' + result[0] + '\n'
         + 'Broadcast: ' + result[1] + '\n'
         + 'Netmask: ' + netmask;
}

/*

result = dotted_cidr_to_start_end( '193.22.87.4', 24 );


var dotquad = '0xaabbccdd'
d2h(dot_quad_to_number('255.255.255.0'))

to_dot_quad(mask_for_prefix(24))
*/


